cr .( DJBHASH routine loading )

\ An algorithm produced by Professor Daniel J. Bernstein and shown first to the
\ world on the usenet newsgroup comp.lang.c. It is one of the most efficient
\ hash functions ever published.

\ Hash of the string [addr u1]
: HASH        ( addr u1 -- u2 )
  #5831 -rot
  bounds do
    dup 5 lshift + i c@ +
  loop
;

\ double lshift
: DLSHIFT     ( d1 u -- d2 )
  0 ?do d2* loop
;

\ double hash of the string [addr u]
: DHASH       ( addr u -- d )
  #5831. 2swap
  bounds do
    2dup 5 dlshift d+ i c@ s>d d+
  loop
;
