\ some useful words for string manipulation

\ convert null terminated string [addr] to string [addr u]
: ZCOUNT      ( addr -- addr u )
  dup $FF 0 scan drop over -
;

\ replace in string [addr u] char [c1] by char [c2]
: REPLACE     ( addr u c1 c2 -- )
  swap
  2swap bounds ?do
    i c@ over = if
      over i c!
    then
  loop  2drop
;

\ test if string [addr u] is empty
: EMPTY?      ( addr u -- flag )
  nip 0=
;

\ return substring [addr2 len] from string [addr1 u]
: /SUBSTR     ( addr1 u index len -- addr2 len )
  >r /string r> min
;
